#!/bin/env python3
import sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import urllib.request

import prvni_ui

class Prvni(QDialog, prvni_ui.Ui_Dialog):
    def __init__(self, parent=None):
        super(Prvni, self).__init__(parent)
        self.setupUi(self)
        self.scene=QGraphicsScene()
        self.graphicsView.setScene(self.scene)
        self.bila=QPen(QColor(255,255,255))
        self.bilab=QBrush(QColor(255,255,255))
        self.zluta=QPen(QColor(255,255,0))
        self.zlutab=QBrush(QColor(255,255,0))
        self.cerna=QPen(QColor(0,0,0))
        self.cernab=QBrush(QColor(0,0,0))
        self.cervena=QPen(QColor(255,0,0))
        self.cervenab=QBrush(QColor(255,0,0))
        self.zelena=QPen(QColor(0,255,0))
        self.zelenab=QBrush(QColor(0,255,0))
        self.id_hry=-1


    def start(self):
        self.server=self.lineEdit.text()
        fh=urllib.request.urlopen(self.server+"/start")
        lines=fh.read().decode("utf-8").split("\r\n")

        self.tahu_celkem=lines[1]
        self.cti_odpoved(lines)
        
    def cti_odpoved(self, lines):
        if lines[0][0:5]=="Konec":
            res=lines[0].split(" ")
            if self.dalsi:
                soup=", soupeř získal "+res[3]
            else:
                soup=""
            self.scene.addRect(0,0,400,400, self.bila, self.bilab)
            self.scene.addText("konec hry, získal jste: "+res[2]+soup)
            self.label.setText('')
            self.id_hry=-1
            return

        self.id_hry=lines[0]
        self.zbyva_tahu=lines[1]
        self.plocha=lines[2:12] # nejdriv y, pak x - musi byt krat 2
        self.lovec=[int(x) for x in lines[12].split(" ")]
        if len(lines)>13 and lines[13]!='':
            self.dalsi=True
            self.protivnik=[int(x) for x in lines[13].split(" ")]
        else:
            self.dalsi=False
        self.kresli()

    def kresli(self):
        self.chyba.setText("")            
        self.label.setText("Zbývajících tahů:"+self.zbyva_tahu+"/"+self.tahu_celkem)
        self.nese.setText("Nesete: "+str(self.lovec[2]))
        self.celkem.setText("Donesl jste: "+str(self.lovec[3]))
        self.scene.addRect(0,0,400,400,self.bila,self.bilab)
        for x in range(0,10,1):
            for y in range(0,10,1):
                if self.plocha[y][x*2]=="X":
                   self.scene.addRect(x*40,y*40,40,40,self.cerna, self.cernab)

                elif self.plocha[y][x*2]=="+":
                   self.scene.addRect(x*40,y*40,40,40,self.zelena, self.zelenab)

                elif self.plocha[y][x*2]=="-":
                   self.scene.addRect(x*40,y*40,40,40,self.cervena, self.cervenab)

                elif self.plocha[y][x*2]==".":
                    pass

                else:
                    self.scene.addRect(x*40,y*40,40,40,self.zluta, self.zlutab)

        self.scene.addEllipse((self.lovec[0]-1)*40+2, (self.lovec[1]-1)*40+2, 40-4, 40-4, self.zelena, self.zelenab)
        if self.dalsi:
            self.scene.addEllipse((self.protivnik[0]-1)*40+2, (self.protivnik[1]-1)*40+2, 40-4, 40-4, self.cervena, self.cervenab)


    def hni(self, kam):
       if self.id_hry!=-1:
           if ((kam=="N" and self.lovec[1]==1) or
                (kam=="D" and self.lovec[1]==10) or
                (kam=="L" and self.lovec[0]==1) or
                (kam=="P" and self.lovec[0]==10) or
                (kam=="N" and self.plocha[self.lovec[1]-2][(self.lovec[0]-1)*2]=="X") or
                (kam=="D" and self.plocha[self.lovec[1]][(self.lovec[0]-1)*2]=="X") or 
                (kam=="L" and self.plocha[self.lovec[1]-1][(self.lovec[0]-2)*2]=="X") or 
                (kam=="P" and self.plocha[self.lovec[1]-1][(self.lovec[0])*2]=="X")):
                self.chyba.setText("Neplatný tah!")            
           else:
                fh=urllib.request.urlopen(self.server+"/tah?id="+self.id_hry+"&pohyb="+kam)
                lines=fh.read().decode("utf-8").split("\r\n")
                self.cti_odpoved(lines)
       else:
            self.chyba.setText("Neprobíhá hra!")            

    def skonci(self):
        self.close()

app=QApplication(sys.argv)
form=Prvni()
form.show()
form.hrat.clicked.connect(form.start)
form.konec.clicked.connect(form.skonci)
form.N.clicked.connect(lambda: form.hni("N"))
form.D.clicked.connect(lambda: form.hni("D"))
form.L.clicked.connect(lambda: form.hni("L"))
form.P.clicked.connect(lambda: form.hni("P"))
app.exec_()
